Codeforces Round 932 (Div. 2) ---- F. Andrey‘s Tree ---- 题解

2024-04-05 02:36

本文主要是介绍Codeforces Round 932 (Div. 2) ---- F. Andrey‘s Tree ---- 题解,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

F. Andrey's Tree:

题目描述:

思路解析:

我们假设删除任意一个结点后,我们会将整个树切分为k个联通块,那么可以明确的知道我们只需要连接(k-1)条边就可以将这k个联通块重新连为一棵树。

那么最小代价是啥呢? 图解分析

 第一种情况,有至少一个联通块即拥有小于删除点的数,又有大于删除的数,此时代价就是要增加的边数

第二种情况,没有上诉的联通块。

 我们可以发现我们还是可以将整个联通块连接为 (1,x-1) 和 (x+1,n)的两个联通块,花费为k-2,此时还需要2个花费,将整个联通块连接为(1,n)的联通块,总花费为删除结点后,联通块的个数。

经过此时分析,我们可以发现我们其实已知需要连多少条边,需要多少代价,这是固定的。花费只由是否有一个联通块中既有小于x的值和大于x的值决定。 因为初始是一棵树,那么假如有一条边为2-7,可以发现后面的边无论怎么样,对于删除3,4,6,来说,一定有个联通块含有(2和7)满足上诉要求,则此时可以通过前缀和来实现。

根据前两个图发现,只要两种连接情况 (x,x+1) (x,x-1)(y,y+2), 且x为联通块的最小值或者最大值,y=删除值-1,那么我们只要维护每个联通块的最小值和最大值即可,并且维护删除结点后,有哪些联通块即可。

代码实现:

import java.io.*;
import java.math.BigInteger;
import java.util.*;import static java.util.Collections.*;public class Main {static int inf = (int) 1e9;static int mod = 998244353;public static void main(String[] args) throws IOException {int t = f.nextInt();while (t > 0) {solve();t--;}w.flush();w.close();br.close();}static int[] maxIn;static int[] maxOut;static int[] minIn;static int[] minOut;static int[] p;static Vector<Integer>[] g;static int n;public static void solve() {n = f.nextInt();g = new Vector[n];for (int i = 0; i < n; i++) {g[i] = new Vector<>();}int[] d = new int[n];for (int i = 0; i < n - 1; i++) {int u = f.nextInt() - 1;int v = f.nextInt() - 1;g[u].add(v);g[v].add(u);if (u > v) {int tmp = u;u = v;v = tmp;}d[u + 1]++;d[v]--;}for (int i = 1; i < n; i++) {d[i] += d[i - 1];}d[0] = d[n - 1] = 1;for (int i = 0; i < n; i++) {d[i] = d[i] >= 1 ? 1 : 0;}maxIn = new int[n];minIn = new int[n];maxOut = new int[n];minOut = new int[n];p = new int[n];Arrays.fill(minOut, n);dfs1(0);dfs2(0);for (int x = 0; x < n; x++) {int res = g[x].size() - d[x];w.println(res + " " + (g[x].size() - 1));ArrayList<int[]> q = new ArrayList<>();for (int i = 0; i < g[x].size(); i++) {int y = g[x].get(i);if (y == p[x]){q.add(new int[] {minOut[x], maxOut[x]});}else {q.add(new int[]{minIn[y], maxIn[y]});}}int lst = -1;q.sort(new Comparator<int[]>() {@Overridepublic int compare(int[] o1, int[] o2) {return o1[0] - o2[0];}});for (int[] a : q) {if (a[0] >= x) break;if (lst != - 1) w.println(a[0] + 1 + " " + a[0]);lst = a[0];}lst = -1;q.sort(new Comparator<int[]>() {@Overridepublic int compare(int[] o1, int[] o2) {return o2[1] - o1[1];}});int c = 0;for (int[] a : q) {if (a[1] <= x) break;if (lst != - 1 && (c == 0 || a[0] > x)) w.println(a[1] + 2 + " " + (a[1] + 1));lst = a[0];c |= (a[0] < x ? 1 : 0);}if (c == 0 && x > 0 && x + 1 < n) w.println(x + " " + (x + 2));w.println();}}static void dfs1(int x) {minIn[x] = x;maxIn[x] = x;for (int i = 0; i < g[x].size(); i++) {int y = g[x].get(i);if (y == p[x]) continue;p[y] = x;dfs1(y);minIn[x] = Math.min(minIn[y], minIn[x]);maxIn[x] = Math.max(maxIn[y], maxIn[x]);}}static void dfs2(int x) {int[] mx = new int[2];int[] mn = new int[2];mn[0] = mn[1] = n;for (int i = 0; i < g[x].size(); i++) {int y = g[x].get(i);if (y == p[x]) continue;int a = minIn[y];int b = maxIn[y];for (int j = 0; j < 2; j++) {if (a < mn[j]){int tmp = mn[j];mn[j] = a;a = tmp;}if (b > mx[j]){int tmp = mx[j];mx[j] = b;b = tmp;}}}for (int i = 0; i < g[x].size(); i++) {int y = g[x].get(i);if (y == p[x]) continue;int a = mx[mx[0] == maxIn[y] ? 1 : 0];int b = mn[mn[0] == minIn[y] ? 1 : 0];maxOut[y] = Math.max(maxOut[x], Math.max(a, x));minOut[y] = Math.min(minOut[x], Math.min(b, x));dfs2(y);}}static PrintWriter w = new PrintWriter(new OutputStreamWriter(System.out));static Input f = new Input(System.in);static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));static class Input {public BufferedReader reader;public StringTokenizer tokenizer;public Input(InputStream stream) {reader = new BufferedReader(new InputStreamReader(stream), 32768);tokenizer = null;}public String next() {while (tokenizer == null || !tokenizer.hasMoreTokens()) {try {tokenizer = new StringTokenizer(reader.readLine());} catch (IOException e) {throw new RuntimeException(e);}}return tokenizer.nextToken();}public String nextLine() {String str = null;try {str = reader.readLine();} catch (IOException e) {// TODO 自动生成的 catch 块e.printStackTrace();}return str;}public int nextInt() {return Integer.parseInt(next());}public long nextLong() {return Long.parseLong(next());}public Double nextDouble() {return Double.parseDouble(next());}public BigInteger nextBigInteger() {return new BigInteger(next());}}
}

这篇关于Codeforces Round 932 (Div. 2) ---- F. Andrey‘s Tree ---- 题解的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/877437

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

C语言 | Leetcode C语言题解之第393题UTF-8编码验证

题目: 题解: static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num & MASK1) == 0) {return

C - Word Ladder题解

C - Word Ladder 题解 解题思路: 先输入两个字符串S 和t 然后在S和T中寻找有多少个字符不同的个数(也就是需要变换多少次) 开始替换时: tips: 字符串下标以0开始 我们定义两个变量a和b,用于记录当前遍历到的字符 首先是判断:如果这时a已经==b了,那么就跳过,不用管; 如果a大于b的话:那么我们就让s中的第i项替换成b,接着就直接输出S就行了。 这样

树(Tree)——《啊哈!算法》

树 什么是树?树是一种特殊的图,不包含回路的连通无向树。 正因为树有着“不包含回路”这个特点,所以树就被赋予了很多特性。 一棵树中的任意两个结点有且仅有唯一的一条路径连通。一棵树如果有n个结点,那么它一定恰好有n-1条边。在一棵树中加一条边将会构成一个回路。 一棵树有且只有一个根结点。 没有父结点的结点称为根结点(祖先)。没有子结点的结点称为叶结点。如果一个结点既不是根结点也不是叶

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor